#include "StdAfx.h"
#include "MainDialog.h"
#include "resource.h"
#include "misc.h"

MainDialog::MainDialog(UINT idResource)
	: Dialog( idResource )
	, slaveMode( FALSE )
{
}

MainDialog::~MainDialog(void)
{
	UnregisterClass( szWindowClass, hInst );
}

INT_PTR CALLBACK MainDialog::DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	UINT value;
	TCHAR path[_MAX_PATH];
	INT_PTR ret;

	ret = sync.TranslateMessage( m_hDlg, uMsg, wParam, lParam );
	if ( ret ) {
		return ret;
	}

	switch( uMsg )
	{
	case WM_INITDIALOG:
		//MessageBox( m_hDlg, _T("Wait For Debug Connection"), szTitle, MB_OK );
		GetModuleFileName( NULL, path, lengthof(path) );
		if ( sync.Init( m_hDlg, _T("TestMemory"), sizeof(SHAREDSTRUCT), path ) == FALSE ) {
			MessageBox( m_hDlg, _T("Ls"), szTitle, MB_OK );
			DestroyWindow( m_hDlg );
		}
		shared = (SHAREDSTRUCT*)sync.GetSharedPointer();
		slaveMode = ( sync.GetRunMode() == RUN_MODE_SLAVE );
		EnableItem( IDC_BTN_UPDATE, sync.GetRunMode() == RUN_MODE_MASTER );
		EnableItem( IDC_EDIT, sync.GetRunMode() == RUN_MODE_MASTER );
		break;

	case WM_SHARED_UPDATE:
		SetItemInt( IDC_EDIT, shared->dw1, FALSE );
		break;

	case WM_SHARED_MODE:
		slaveMode = ( sync.GetRunMode() == RUN_MODE_SLAVE );
		EnableItem( IDC_BTN_UPDATE, sync.GetRunMode() == RUN_MODE_MASTER );
		EnableItem( IDC_EDIT, sync.GetRunMode() == RUN_MODE_MASTER );
		break;

	case WM_COMMAND:
		wmId	= LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch( wmId )
		{
		case IDC_BTN_UPDATE:
			if ( !slaveMode ) {
				value = GetItemInt( IDC_EDIT, NULL, FALSE );
				shared->dw1 = value;
				sync.SharedUpdate();
			}
			break;

		case IDOK:
		case IDCANCEL:
			sync.CloseApp( m_hDlg );
			break;
		}
		break;

	case WM_CLOSE:
		sync.CloseApp( m_hDlg );
		break;

	case WM_PAINT:
		hdc = BeginPaint(m_hDlg, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(m_hDlg, &ps);
		break;

	case WM_DESTROY:
		PostQuitMessage( 0 );
		break;

	default:
		return DefWindowProc(m_hDlg, uMsg, wParam, lParam);
		break;
	}

	return 0;
}

BOOL MainDialog::InitInstance( HWND hParent )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)_RootWndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= DLGWINDOWEXTRA;
	wcex.hInstance		= hInst;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_BTNFACE+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}

BOOL MainDialog::DoModeless(HWND hParent, int nCmdShow)
{
	BOOL bRet = FALSE;

	if ( InitInstance() ) {
		if ( bRet = Dialog::DoModeless( hParent, nCmdShow ) ) {
			SetWindowText( m_hDlg, slaveMode ? _T("Slave") : _T("Master") );
		}
	}
	return bRet;
}

