#ifndef _SYNCRUN_H_
#define _SYNCRUN_H_

#define RUN_MODE_SINGLE	0
#define RUN_MODE_MASTER	1
#define RUN_MODE_SLAVE	2

#define WM_SHARED_UPDATE	(WM_APP+100)
#define WM_SHARED_HWND		(WM_APP+101)
#define WM_SHARED_CLOSE		(WM_APP+102)
#define WM_SHARED_MODE		(WM_APP+103)

class SyncRun
{
public:
	SyncRun(void);
	virtual ~SyncRun(void);

	BOOL Init(HWND hWnd, TCHAR *ident, DWORD size, TCHAR *path);
	INT_PTR CALLBACK TranslateMessage( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
	BOOL SharedUpdate(void);
	void CloseApp( HWND hWnd );
	void *GetSharedPointer(void);
	UINT GetRunMode(void) { return runMode; }

protected:
#pragma pack(1)
	typedef struct _SHARED_STRUCT {
		DWORD masterWnd;
		BYTE ref;
		LPVOID customStruct;
	} SHARED_STRUCT;
#pragma pack()

	DWORD sharedSize;
	HANDLE sharedHandle;
	SHARED_STRUCT* sharedPointer;
	TCHAR sharedIdent[256];
	HWND slaveWnd;
	UINT runMode;
	BOOL waitForSlaveClose;
	TCHAR slavePath[_MAX_PATH];
};

#endif//_SYNCRUN_H_
