#include "stdafx.h"
#include <windows.h>
#include "misc.h"
#include "resource.h"


ULONGLONG GetLocalTime64( void )
{
	FILETIME ft;
	ULARGE_INTEGER ui;
	SYSTEMTIME st;

	GetLocalTime( &st );
	SystemTimeToFileTime( &st, &ft );
	ui.LowPart = ft.dwLowDateTime;
	ui.HighPart = ft.dwHighDateTime;
	return ui.QuadPart;
}

BOOL GetFileVersionDW( TCHAR *path, DWORD *value4 )
{
	DWORD	handle;
	DWORD	rlen;
	DWORD	*lang;
	BYTE	*buf;
	UINT	vlen;
	TCHAR	strLang[9];
	TCHAR	strStream[100];
	TCHAR	*strBuf;

	rlen = GetFileVersionInfoSize( path, &handle );
	buf = new BYTE[rlen];

	if ( ( path == NULL ) || ( value4 == NULL ) ) {
		return FALSE;
	}

	if ( buf ) {
		GetFileVersionInfo( path, handle, rlen, buf );
		
		if ( VerQueryValue( buf, _T("\\VarFileInfo\\Translation"), (LPVOID*)&lang, &vlen ) ) {
			_stprintf_s( strLang, 9, _T("%04x%04x"), LOWORD(*lang), HIWORD(*lang) );
			_stprintf_s( strStream, 100, _T("\\StringFileInfo\\%s\\ProductVersion"), strLang );
			if ( VerQueryValue( buf, strStream, (LPVOID*)&strBuf, &vlen ) ) {
				if ( _stscanf_s( strBuf, _T("%d,%d,%d,%d"), &value4[0], &value4[1], &value4[2], &value4[3] ) != 4 ) {
					_stscanf_s( strBuf, _T("%d.%d.%d.%d"), &value4[0], &value4[1], &value4[2], &value4[3] );
				}
				delete[] buf;
				return TRUE;
			}
		}

		delete[] buf;
		return FALSE;
	}

	return FALSE;
}

BOOL GetCopyright( TCHAR *path, TCHAR *cp, int len )
{
	DWORD	handle;
	DWORD	rlen;
	DWORD	*lang;
	BYTE	*buf;
	UINT	vlen;
	TCHAR	strLang[9];
	TCHAR	strStream[100];
	TCHAR	*strBuf;

	rlen = GetFileVersionInfoSize( path, &handle );
	buf = new BYTE[rlen];

	if ( ( path == NULL ) || ( cp == NULL ) ) {
		return FALSE;
	}

	if ( buf ) {
		GetFileVersionInfo( path, handle, rlen, buf );
		
		if ( VerQueryValue( buf, _T("\\VarFileInfo\\Translation"), (LPVOID*)&lang, &vlen ) ) {
			_stprintf_s( strLang, 9, _T("%04x%04x"), LOWORD(*lang), HIWORD(*lang) );
			_stprintf_s( strStream, 100, _T("\\StringFileInfo\\%s\\LegalCopyright"), strLang );
			if ( VerQueryValue( buf, strStream, (LPVOID*)&strBuf, &vlen ) ) {
				_tcscpy_s( cp, len, strBuf );
				delete[] buf;
				return TRUE;
			}
		}

		delete[] buf;
		return FALSE;
	}

	return FALSE;
}

void LogOutput( HWND hWnd, TCHAR *format, ... )
{
	va_list args;
	int len, len2;
	TCHAR *buffer, *buffer2;

	va_start( args, format );
	len = _vsctprintf( format, args ) + 1;

	buffer = new TCHAR[len];
	_vstprintf_s( buffer, len, format, args );

	len2 = GetWindowTextLength( hWnd ) + len + 10;
	buffer2 = new TCHAR[len2];
	GetWindowText( hWnd, buffer2, len2 );

	_tcscat_s( buffer2, len2, buffer );

	SetWindowText( hWnd, buffer2 );

	SendMessage( hWnd, EM_SETSEL, 0, -1);
	SendMessage( hWnd, EM_SETSEL, -1, -1);
	SendMessage( hWnd, EM_SCROLLCARET, 0, 0 );

	delete[] buffer;
	delete[] buffer2;
}
